
<!doctype html>
<html lang="nl">

<head>
  <meta charset="utf-8">
  <title>Chat</title>
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
  <script>
      //https://stackoverflow.com/questions/1586330/access-get-directly-from-javascript
      var parts = window.location.search.substr(1).split("&");
      var $_GET = {};
      for (var i = 0; i < parts.length; i++) {
        var temp = parts[i].split("=");
        $_GET[decodeURIComponent(temp[0])] = decodeURIComponent(temp[1]);
      }
</script>

  <meta name="theme-color" content="#fafafa">
  <style>
    div#sendform-container {
      position: fixed;
      bottom: 0;
      left: 0;
      width: 100vw;
      display: flex;
      margin: auto 0 0;
    }
  
  div#sendform-container * {
      font-size: 15px;
  }

    #messagetext {
      flex-grow: 1;
    }

    .messagecontainer {
      font: -apple-system-body;
      margin-bottom: 10px;
    }

    .topcontent {
      font-size: 12px;
      margin-top: 5px;
      margin-bottom: 7px;
    }


    .attachmentImage {
      max-height: calc(0.40 * 100vh);
      max-width: 100%;
    }

    .blackoverlay {
      background-color: black;
      position: fixed;
      width: 100vw;
      height: 100vh;
      margin: auto;
      top: 0;
      bottom: 0;
      left: 0;
      right: 0;
      z-index: 999;
      text-align: center;
    }

    .blackoverlay .attachmentImage {
      height: 100vh;
    }

    .blackoverlay .closeEnlargementButton {
      position: absolute;
      top: 10px;
      right: 20px;
      color: white;
      font-size: 30px;
      cursor: pointer;
    }

    .contentcontainer {
      margin-top: 0;
      margin-bottom: 1px;
    }
    .contentcontainer + .attachmentImage {
      margin-top: 5px;
    }
    hr {
      border-bottom: none;
      border-top: solid 1px #9f9f9f;
    }
  /* Dark mode */
  @media (prefers-color-scheme: dark) {
      body, input, button {
          background-color: #000;
          color: white;
      }
      
  }
  
  </style>
</head>

<body>
<div id="messages">

</div>
<div id="sendform-container">
  <input id="messagetext" type="text">
  <input type="button" value="Verzend" id="messagebutton" onclick="sendMessage(this)">
</div>
<script>
    window.onload = function () {
        document.getElementById("messages").style.marginBottom = document.getElementById("sendform-container").clientHeight + "px";
        document.getElementById("messagetext").addEventListener("keyup", function (e) {
            if (e.key === "Enter") {
                document.getElementById("messagebutton").click();
            }
        });

    };

    function addMessage(message, withHeader = true, atBeginning = false) {
        if(Array.isArray(message)) {
            for(var i=0; i<message.length; i++) {
                addMessage(message[i]);
            }
            return;
        }
        
        var user = message["user"];
        var timestamp = message["timestamp"];
        var imgpath = message["imgpath"];
        var content = message["message"];
        var id = message["id"];

        if (!user || !timestamp || !id) {
            return;
        }

        var messagecontainer = document.createElement("div");
        messagecontainer.className = "messagecontainer";
        messagecontainer.id = "message" + id;

        var idholder = document.createElement("input");
        idholder.type = "hidden";
        idholder.value = id;
        idholder.className = "idholder";
        messagecontainer.appendChild(idholder);

      if (withHeader) {
        // create a separator
        var separator = document.createElement("hr");
        messagecontainer.appendChild(separator)
        //topcontent is username + timestamp
        var topcontent = document.createElement("p");
        topcontent.innerHTML = "<b>" + user + "</b> - " + timestamp;
        topcontent.className = "topcontent";
        messagecontainer.appendChild(topcontent);
      }


        var contentcontainer = document.createElement("p");
        contentcontainer.innerHTML = content;
        contentcontainer.className = "contentcontainer";
        messagecontainer.appendChild(contentcontainer);

        if (imgpath || imgpath !== "") {
            var image = document.createElement("img");
            image.src = imgpath;
            image.id = "image" + id;
            image.className = "attachmentImage";
            image.title = "Bijgevoegde afbeelding";
            image.setAttribute("onclick", "enlargeImage(this);");
            messagecontainer.appendChild(image);
        }
            
            var messageselement = document.getElementById("messages")
            if (atBeginning === true) {
                messageselement.insertBefore(messagecontainer, messageselement.childNodes[0]);
            }
            else {
                messageselement.appendChild(messagecontainer);
                window.scrollTo(0, document.body.scrollHeight);
            }
        
    }

    function enlargeImage(imageEl) {
        var overlay = document.createElement("div");
        overlay.className = "blackoverlay";
        document.body.appendChild(overlay);

        var closebutton = document.createElement("span");
        closebutton.className = "closeEnlargementButton";
        closebutton.innerHTML = "&times;";
        closebutton.setAttribute("onclick", "closeEnlargement()");
        overlay.appendChild(closebutton);

        overlay.appendChild(imageEl);
    }

    function closeEnlargement() {
        var image = document.querySelector(".blackoverlay .attachmentImage");
        var messageid = parseInt(image.id.replace(/^\D+/g, ''));
        document.getElementById("message" + messageid).appendChild(image);
        var overlays = document.querySelectorAll(".blackoverlay");
        for(var i=0;i<overlays.length;i++){
            overlays[i].remove();
        }
    }

    function sendMessage(button) {
        var inputfield = document.getElementById("messagetext")
        var message = inputfield.value;
        if (message != null) {
            button.disabled = true;
            prompt(JSON.stringify({message: message, action: "send"}))
        }
    }
    var loadedDays = 1;
    function loadMoreMessages(){
      prompt(JSON.stringify({loadedDays: loadedDays, increaseBy: 2, action: "loadMoreMessages"}));
    }

    function addLoadMoreMessagesButton(){
        var messageselement = document.getElementById("messages");

        //Remove all present "Load more messages" button
        var presentbuttons = messageselement.querySelectorAll(".loadMoreMessagesBtn");
        for(var i=0; i<presentbuttons.length;i++) {
            presentbuttons[i].remove()
        }

        var newestid = parseInt(messageselement.children[0].querySelector(".idholder").value);
        if(newestid === 1){
            //All messages have already been loaded
            return
        }
        var button = document.createElement("button");
        button.innerText = "Laad meer";
        button.style.display = "block";
        button.style.margin = "0 auto";
        button.className = "loadMoreMessagesBtn";
        button.addEventListener("click", loadMoreMessages);
        messageselement.insertBefore(button, messageselement.childNodes[0]);
    }
</script>
</body>

</html>
